//UseMyTypo.js by Henryk Jursz, HenJ, http://www.jursz.com, august 2005 - december 2006, april - june 2007, july - september 2007, january 2010, june 2014, november 2015, october 2020
//An InDesign CS-CS6, CC-CC2019 JavaScript for typograhic changes

//all script messages
myScriptIDC	= "\u017Baden dokument InDesigna nie jest otwarty lub nie zaznaczono \u017Cadnego obiektu!";
UMT_Script	= "UseMyTypo 2.2h, \u00a92005-2020 Henryk Jursz";
UMT_WorkOn	= "Pracuj na:";
UMT_WOnSel	= ["ca\u0142ym dokumencie", "zaznaczeniu", "wybranym w\u0105tku"];
UMT_Layer	= "warstwie: ";
UMT_LngWork	= ", w j\u0119zyku";
UMT_Lng_Any	= "dowolnym";
UMT_Doubled	= "Usu\u0144 wielokrotne:";
UMT_DblSp	= "spacje";
UMT_DblTab	= "tabulatory";
UMT_DblRet	= "odst\u0119py akapitowe";
UMT_RemSps	= "Usu\u0144 zb\u0119dne spacje przy tabulatorach i odst\u0119pach akapitowych";
UMT_QuotTyp	= "Skoryguj spacje przy cudzys\u0142owach:";
UMT_QT		= "Tekst";//<2009> thin french space - quotes variant 1 in array
UMT_QuotTAr	= ["\u00AB"+UMT_QT+"\u00BB","\u00AB\u2009"+UMT_QT+"\u2009\u00BB","\u00BB"+UMT_QT+"\u00AB","\u2018"+UMT_QT+"\u2019","\u201A"+UMT_QT+"\u2018","\u2019"+UMT_QT+"\u2019","\u201C"+UMT_QT+"\u201D","\u201D"+UMT_QT+"\u201D","\u201E"+UMT_QT+"\u201C","\u201E"+UMT_QT+"\u201D","\u2039"+UMT_QT+"\u203A"];
UMT_QuotTOp	= ["\u00AB","\u00AB","\u00BB","\u2018","\u201A","\u2019","\u201C","\u201D","\u201E","\u201E","\u2039"];
UMT_QuotTCl	= ["\u00BB","\u00BB","\u00AB","\u2019","\u2018","\u2019","\u201D","\u201D","\u201C","\u201D","\u203A"];
UMT_InsSp_b	= "Wstaw spacje przed:";
UMT_InsSp_a = "Wstaw spacje po:";
UMT_RemSp_b	= "Usu\u0144 spacje przed:";
UMT_RemSp_a = "Usu\u0144 spacje po:";
UMT_ChngMin	= "Wymie\u0144 dywiz otoczony spacjami na:";
UMT_Hyphs	= ["p\u00F3\u0142pauz\u0119", "pauz\u0119"];
UMT_DigMin	= "Wymie\u0144 dywiz mi\u0119dzy cyframi na:";
UMT_DigHyph	= ["p\u00F3\u0142pauz\u0119", "pauz\u0119", "twardy dywiz", "kresk\u0119 cyfrow\u0105"];
UMT_After	= "Twarda spacja po wyrazach z pliku:";
UMT_Before	= "Twarda spacja przed wyrazami z pliku:";
UMT_ChgSp	= "Wymie\u0144 twarde spacje na spacje:";
UMT_CSpList = ["z atrybutem \u201EBez dzielenia\u201D"];
UMT_CSpLst2 = ["z atrybutem \u201EBez dzielenia\u201D"];
UMT_CSpStyl = "ze stylem: ";
UMT_HardCS3	= "twarde rozci\u0105gliwe (CS3)";
UMT_WWW		= "Adresom internetowym nadaj styl:";
UMT_CSpWWW	= ["nie zmieniaj"];
UMT_AdFile	= "Zastosuj zmiany z pliku:";
UMT_noAdF	= "Nie mog\u0119 wczyta\u0107 pliku: ";
UMT_noChF	= "Niepoprawna konstrukcja pliku: ";
UMT_Errors	= "Nie mo\u017Cna by\u0142o wykona\u0107 wszystkich zada\u0144!\nCzy uruchomi\u0107 skrypt ponownie?";

//my additional definitions
var UMT_AnyLetter	= ["a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "w", "v", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "W", "V", "X", "Y", "Z", "<0105>", "<0104>", "<0107>", "<0106>", "<0119>", "<0118>", "<0142>", "<0141>", "<0144>", "<0143>", "<00F3>", "<00D3>", "<015B>", "<015A>", "<017A>", "<0179>", "<017C>", "<017B>"];
var UMT_AnyDigit	= ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"];
var UMT_AnyPun		= [",", ".", ":", ";", "!", "?"];
var UMT_AnyBrO		= ["(", "{", "["];
var UMT_AnyBrC		= [")", "}", "]"];
var UMT_AnyWSp		= [" ", "^n", "^t", "^p", "^s"];
var UMT_OpError		= false;

//preferences variables - default settings - next step: loading settings from file
var myUMT_WorkOn_DropDown	= 1;
var myUMT_Lng_Name			= UMT_Lng_Any;
var myUMT_Lng_DropDown		= 0;
var myUMT_DblSp_Check		= true;
var myUMT_DblTab_Check		= false;
var myUMT_DblRet_Check		= false;
var myUMT_RemSps_Check		= true;
var myUMT_QuotLng_Check		= false;
var myUMT_QuotLng_DropDown	= 9;
var myUMT_InsSp_b_Check		= false;
var myUMT_InsSp_a_Check		= false;
var myUMT_RemSp_b_Check		= false;
var myUMT_RemSp_a_Check		= false;
var myUMT_InsSp_b_Edit		= "({[";
var myUMT_InsSp_a_Edit		= ")}]:;,?!";
var myUMT_RemSp_b_Edit		= "@%)}]:;,./?!";
var myUMT_RemSp_a_Edit		= "@({[/";
var myUMT_MinusSpaces_Check	= true;
var myUMT_ChngMin_DropDown	= 0;
var myUMT_After_Check		= true;
var myUMT_After_DropDown	= 0;
var myUMT_After_Name		= "UMT2.0_after_PL.txt";
var myUMT_Before_Check		= false;
var myUMT_Before_DropDown	= 0;
var myUMT_Before_Name		= "UMT2.0_before_PL.txt";
var myUMT_ChgSp_Check		= false;
var myUMT_ChgSp_DropDown	= 0;
var myUMT_ChgSp_Name		= "";
var myUMT_WWW_Check			= false;
var myUMT_WWW_DropDown		= 0;
var myUMT_WWW_Name			= "";
var myUMT_AdFile_Check		= false;
var myUMT_AdFile_DropDown	= 0;
var myUMT_AdFile_Name		= "UMT2.0_changes_PL.txt";
var myUMT_DigMin_Check		= false;
var myUMT_DigMin_DropDown	= 3;
var myUMT_WorkOn_Name		= "";

//is InDesign?
if (((app.name != "Adobe InDesign") && (app.name != "Adobe InCopy")) || (((app.name == "Adobe InDesign") || (app.name == "Adobe InCopy")) && (app.documents.length == 0)))
	{
	alert(myScriptIDC);
	}
else if (app.documents.length != 0)
	{
	var myUMT_AppVersion = parseFloat(app.version);
	(myUMT_AppVersion < 4) ? (app.userInteractionLevel = UserInteractionLevels.interactWithAll) : (app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll);

	//get base document elements
	var myDoc = app.documents[0];
	var myDocSelection = app.selection;
	var myDocSelectionZero = app.selection[0];

	//load saved settings from preference file
	UMT_PrefsFileOpen();

	//getting languages
	UMT_Lng = [UMT_Lng_Any];
	for (x = 1; x < app.languagesWithVendors.length; x ++)
		{
		UMT_Lng.push(app.languagesWithVendors[x].name);
		}
	UMT_Lng.sort();
	myUMT_Lng_DropDown = HJ_IndexOfArray(UMT_Lng, myUMT_Lng_Name);
	if (myUMT_Lng_DropDown < 0) myUMT_Lng_DropDown = (UMT_Lng.length - 1);
	myUMT_Lng_Name = UMT_Lng[myUMT_Lng_DropDown];
	var UMT_LngList = new Array;
	for (x = 0; x < UMT_Lng.length-1; x ++)
		{
		for (y = 1; y < app.languagesWithVendors.length; y ++)
			{ if (UMT_Lng[x] == app.languagesWithVendors[y].name) UMT_LngList.push(app.languagesWithVendors[y]); }
		}

	//create active document layers list
	myUMT_WOnLayers = new Array;
	var myDocLayers = myDoc.layers;
	for (x = 0; x < myDocLayers.length; x ++)
		{
		if ((!myDocLayers[x].locked) && (myDocLayers[x].visible))
			{
			myUMT_WOnLayers.push(myDocLayers[x]);
			UMT_WOnSel.push(UMT_Layer + myDocLayers[x].name);
			}
		}
	myUMT_WorkOn_DropDown = HJ_IndexOfArray(UMT_WOnSel, myUMT_WorkOn_Name);
	if (myUMT_WorkOn_DropDown < 0) myUMT_WorkOn_DropDown = 1;

	//create active document character styles list
	var UMT_CStyleList = new Array;
	UMT_CStyleList.push("");
	var myDocCharStyles = myDoc.characterStyles;
	for (x = 1; x < myDocCharStyles.length; x ++)
		{
		UMT_CSpList.push(myDocCharStyles[x].name);
		UMT_CSpLst2.push(UMT_CSpStyl + myDocCharStyles[x].name);
		UMT_CSpWWW.push(myDocCharStyles[x].name);
		UMT_CStyleList.push(myDocCharStyles[x]);
		}
	if (myUMT_AppVersion > 3.99)
		{
		var myDocCharStylesGroup = myDoc.characterStyleGroups;
		for (x = 0; x < myDocCharStylesGroup.length; x ++)
			{
			for (y = 0; y < myDocCharStylesGroup[x].allCharacterStyles.length; y ++)
				{
				var myUMT_StyleGr = myDocCharStylesGroup[x].name;
				if (myUMT_StyleGr != myDocCharStylesGroup[x].allCharacterStyles[y].parent.name)
					{
					myUMT_StyleGr += (":" + myDocCharStylesGroup[x].allCharacterStyles[y].parent.name);
					}
				UMT_CSpList.push(myDocCharStylesGroup[x].allCharacterStyles[y].name + " (" + myUMT_StyleGr + ")");
				UMT_CSpLst2.push(UMT_CSpStyl + myDocCharStylesGroup[x].allCharacterStyles[y].name + " (" + myUMT_StyleGr + ")");
				UMT_CSpWWW.push(myDocCharStylesGroup[x].allCharacterStyles[y].name + " (" + myUMT_StyleGr + ")");
				UMT_CStyleList.push(myDocCharStylesGroup[x].allCharacterStyles[y]);
				}
			}
		}
	if (myUMT_AppVersion > 3.99) UMT_CSpList.push(UMT_HardCS3);
	if (myUMT_AppVersion > 3.99) UMT_CSpLst2.push(UMT_HardCS3);
	myUMT_ChgSp_DropDown = HJ_IndexOfArray(UMT_CSpList, myUMT_ChgSp_Name);
	if (myUMT_ChgSp_DropDown < 0) myUMT_ChgSp_DropDown = 0;
	myUMT_WWW_DropDown = HJ_IndexOfArray(UMT_CSpWWW, myUMT_WWW_Name);
	if (myUMT_WWW_DropDown < 0) myUMT_WWW_DropDown = 0;

	//create active document paragraph styles list
	var UMT_PStyleList = new Array;
	var UMT_PStyleNames = new Array;
	var myDocParaStyles = myDoc.paragraphStyles;
	for (x = 1; x < myDocParaStyles.length; x ++)
		{
		UMT_PStyleNames.push(myDocParaStyles[x].name);
		UMT_PStyleList.push(myDocParaStyles[x]);
		}
	if (myUMT_AppVersion > 3.99)
		{
		var myDocParaStylesGroup = myDoc.paragraphStyleGroups;
		for (x = 0; x < myDocParaStylesGroup.length; x ++)
			{
			for (y = 0; y < myDocParaStylesGroup[x].allParagraphStyles.length; y ++)
				{
				var myUMT_StyleGr = myDocParaStylesGroup[x].name;
				if (myUMT_StyleGr != myDocParaStylesGroup[x].allParagraphStyles[y].parent.name)
					{
					myUMT_StyleGr += (":" + myDocParaStylesGroup[x].allParagraphStyles[y].parent.name);
					}
				UMT_PStyleNames.push(myDocParaStylesGroup[x].allParagraphStyles[y].name + " (" + myUMT_StyleGr + ")");
				UMT_PStyleList.push(myDocParaStylesGroup[x].allParagraphStyles[y]);
				}
			}
		}

	//checking external files existing
	var UMT_AfterN	= UMT_GetFiles("UMT2.0_after_*");
	myUMT_After_DropDown = HJ_IndexOfArray(UMT_AfterN, myUMT_After_Name);
	if (myUMT_After_DropDown < 0) myUMT_After_DropDown = 0;
	var UMT_BeforeN	= UMT_GetFiles("UMT2.0_before_*");
	myUMT_Before_DropDown = HJ_IndexOfArray(UMT_BeforeN, myUMT_Before_Name);
	if (myUMT_Before_DropDown < 0) myUMT_Before_DropDown = 0;
	var UMT_AdFileN	= UMT_GetFiles("UMT2.0_changes_*");
	myUMT_AdFile_DropDown = HJ_IndexOfArray(UMT_AdFileN, myUMT_AdFile_Name);
	if (myUMT_AdFile_DropDown < 0) myUMT_AdFile_DropDown = 0;

	//UseMyTypo GUI - user can choose some options
	var myUMT_Dialog = app.dialogs.add({name: UMT_Script, canCancel: true});
	with (myUMT_Dialog)
		{
		with (dialogColumns.add())
			{
			with(borderPanels.add())
				{
				with (dialogColumns.add())
					{
					with (dialogRows.add())
						{
						staticTexts.add({staticLabel: UMT_WorkOn});
						myUMT_WorkOn_DropDown = dropdowns.add({stringList: UMT_WOnSel, selectedIndex: myUMT_WorkOn_DropDown});
						staticTexts.add({staticLabel: UMT_LngWork});
						myUMT_Lng_DropDown = dropdowns.add({stringList: UMT_Lng, selectedIndex: myUMT_Lng_DropDown});
						}
					with (dialogRows.add())
						{
						staticTexts.add({staticLabel: UMT_Doubled});
						myUMT_DblSp_Check = checkboxControls.add({staticLabel: UMT_DblSp, checkedState: myUMT_DblSp_Check});
						myUMT_DblTab_Check = checkboxControls.add({staticLabel: UMT_DblTab, checkedState: myUMT_DblTab_Check});
						myUMT_DblRet_Check = checkboxControls.add({staticLabel: UMT_DblRet, checkedState: myUMT_DblRet_Check});
						}
					myUMT_RemSps_Check = checkboxControls.add({staticLabel: UMT_RemSps, checkedState: myUMT_RemSps_Check});
					with (dialogRows.add())
						{
						with (dialogColumns.add())
							{
							myUMT_QuotLng_Check = checkboxControls.add({staticLabel: UMT_QuotTyp, checkedState: myUMT_QuotLng_Check});
							myUMT_InsSp_b_Check = checkboxControls.add({staticLabel: UMT_InsSp_b, checkedState: myUMT_InsSp_b_Check});
							myUMT_InsSp_a_Check = checkboxControls.add({staticLabel: UMT_InsSp_a, checkedState: myUMT_InsSp_a_Check});
							myUMT_RemSp_b_Check = checkboxControls.add({staticLabel: UMT_RemSp_b, checkedState: myUMT_RemSp_b_Check});
							myUMT_RemSp_a_Check = checkboxControls.add({staticLabel: UMT_RemSp_a, checkedState: myUMT_RemSp_a_Check});
							myUMT_MinusSpaces_Check = checkboxControls.add({staticLabel: UMT_ChngMin, checkedState: myUMT_MinusSpaces_Check});
							myUMT_DigMin_Check = checkboxControls.add({staticLabel: UMT_DigMin, checkedState: myUMT_DigMin_Check});
							myUMT_After_Check = checkboxControls.add({staticLabel: UMT_After, checkedState: myUMT_After_Check});
							myUMT_Before_Check = checkboxControls.add({staticLabel: UMT_Before, checkedState: myUMT_Before_Check});
							myUMT_ChgSp_Check = checkboxControls.add({staticLabel: UMT_ChgSp, checkedState: myUMT_ChgSp_Check});
							myUMT_WWW_Check = checkboxControls.add({staticLabel: UMT_WWW, checkedState: myUMT_WWW_Check});
							myUMT_AdFile_Check = checkboxControls.add({staticLabel: UMT_AdFile, checkedState: myUMT_AdFile_Check});
							}
						with (dialogColumns.add())
							{
							myUMT_QuotLng_DropDown = dropdowns.add({stringList: UMT_QuotTAr, selectedIndex: myUMT_QuotLng_DropDown, minWidth: 260});
							myUMT_InsSp_b_Edit = textEditboxes.add({editContents: myUMT_InsSp_b_Edit, minWidth: 260});
							myUMT_InsSp_a_Edit = textEditboxes.add({editContents: myUMT_InsSp_a_Edit, minWidth: 260});
							myUMT_RemSp_b_Edit = textEditboxes.add({editContents: myUMT_RemSp_b_Edit, minWidth: 260});
							myUMT_RemSp_a_Edit = textEditboxes.add({editContents: myUMT_RemSp_a_Edit, minWidth: 260});
							myUMT_ChngMin_DropDown = dropdowns.add({stringList: UMT_Hyphs, selectedIndex: myUMT_ChngMin_DropDown, minWidth: 260});
							myUMT_DigMin_DropDown = dropdowns.add({stringList: UMT_DigHyph, selectedIndex: myUMT_DigMin_DropDown, minWidth: 260});
							myUMT_After_DropDown = dropdowns.add({stringList: UMT_AfterN, selectedIndex: myUMT_After_DropDown, minWidth: 260});
							myUMT_Before_DropDown = dropdowns.add({stringList: UMT_BeforeN, selectedIndex: myUMT_Before_DropDown, minWidth: 260});
							myUMT_ChgSp_DropDown = dropdowns.add({stringList: UMT_CSpLst2, selectedIndex: myUMT_ChgSp_DropDown, minWidth: 260});
							myUMT_WWW_DropDown = dropdowns.add({stringList: UMT_CSpWWW, selectedIndex: myUMT_WWW_DropDown, minWidth: 260});
							myUMT_AdFile_DropDown = dropdowns.add({stringList: UMT_AdFileN, selectedIndex: myUMT_AdFile_DropDown, minWidth: 260});
							}
						}
					}
				}
			}
		}
	if (myUMT_Dialog.show())
		{
		//get the values from the dialog box controls
		myUMT_WorkOn_DropDown	= myUMT_WorkOn_DropDown.selectedIndex;
		myUMT_WorkOn_Name		= UMT_WOnSel[myUMT_WorkOn_DropDown];
		myUMT_Lng_DropDown		= myUMT_Lng_DropDown.selectedIndex;
		myUMT_Lng_Name			= UMT_Lng[myUMT_Lng_DropDown];
		myUMT_DblSp_Check		= myUMT_DblSp_Check.checkedState;
		myUMT_DblTab_Check		= myUMT_DblTab_Check.checkedState;
		myUMT_DblRet_Check		= myUMT_DblRet_Check.checkedState;
		myUMT_RemSps_Check		= myUMT_RemSps_Check.checkedState;
		myUMT_QuotLng_Check		= myUMT_QuotLng_Check.checkedState;
		myUMT_QuotLng_DropDown	= myUMT_QuotLng_DropDown.selectedIndex;
		myUMT_InsSp_b_Check		= myUMT_InsSp_b_Check.checkedState;
		myUMT_InsSp_a_Check		= myUMT_InsSp_a_Check.checkedState;
		myUMT_RemSp_b_Check		= myUMT_RemSp_b_Check.checkedState;
		myUMT_RemSp_a_Check		= myUMT_RemSp_a_Check.checkedState;
		myUMT_InsSp_b_Edit		= myUMT_InsSp_b_Edit.editContents;
		myUMT_InsSp_a_Edit		= myUMT_InsSp_a_Edit.editContents;
		myUMT_RemSp_b_Edit		= myUMT_RemSp_b_Edit.editContents;
		myUMT_RemSp_a_Edit		= myUMT_RemSp_a_Edit.editContents;
		myUMT_MinusSpaces_Check	= myUMT_MinusSpaces_Check.checkedState;
		myUMT_ChngMin_DropDown	= myUMT_ChngMin_DropDown.selectedIndex;
		myUMT_DigMin_Check		= myUMT_DigMin_Check.checkedState;
		myUMT_DigMin_DropDown	= myUMT_DigMin_DropDown.selectedIndex;
		myUMT_After_Check		= myUMT_After_Check.checkedState;
		myUMT_After_DropDown	= myUMT_After_DropDown.selectedIndex;
		myUMT_After_Name		= UMT_AfterN[myUMT_After_DropDown];
		myUMT_Before_Check		= myUMT_Before_Check.checkedState;
		myUMT_Before_DropDown	= myUMT_Before_DropDown.selectedIndex;
		myUMT_Before_Name		= UMT_BeforeN[myUMT_Before_DropDown];
		myUMT_ChgSp_Check		= myUMT_ChgSp_Check.checkedState;
		myUMT_ChgSp_DropDown	= myUMT_ChgSp_DropDown.selectedIndex;
		myUMT_ChgSp_Name		= UMT_CSpList[myUMT_ChgSp_DropDown];
		myUMT_WWW_Check			= myUMT_WWW_Check.checkedState;
		myUMT_WWW_DropDown		= myUMT_WWW_DropDown.selectedIndex;
		myUMT_WWW_Name			= UMT_CSpWWW[myUMT_WWW_DropDown];
		myUMT_AdFile_Check		= myUMT_AdFile_Check.checkedState;
		myUMT_AdFile_DropDown	= myUMT_AdFile_DropDown.selectedIndex;
		myUMT_AdFile_Name		= UMT_AdFileN[myUMT_AdFile_DropDown];

		//remove the dialog box from memory
		myUMT_Dialog.destroy();

		//save preference file and check external files
		UMT_PrefsFileSave();
		if (!myUMT_After_Name)
			{
			myUMT_After_Check = false;
			}
		else if (UMT_FilesLoader(myUMT_After_Name).length < 1) myUMT_After_Check = false;
		if (!myUMT_Before_Name)
			{
			myUMT_Before_Check = false;
			}
		else if (UMT_FilesLoader(myUMT_Before_Name).length < 1) myUMT_Before_Check = false;
		if (!myUMT_AdFile_Name)
			{
			myUMT_AdFile_Check = false;
			}
		else if (UMT_FilesLoader(myUMT_AdFile_Name).length < 1) myUMT_AdFile_Check = false;

		//opened documents&selection checking
		myScriptSelectCheck(myUMT_WorkOn_DropDown);

		//operate by ID version
		if (myUMT_AppVersion < 5)//FR for ID CS&CS2
			{
			//standard CS/CS2 search functions
			var mySubScript = "function myScriptFR(FR_What, FR_ForWhat, FR_WholeWord){var myFR_check = new Array;";
			if ((FR_Select.length == 1) && (FR_Select[0].constructor.name == "Text"))
				{
				mySubScript += "try {";
				mySubScript += "myFR_check = myDocSelectionZero.search(FR_What, FR_WholeWord, true, FR_ForWhat);";
				mySubScript += "} catch (e) {UMT_OpError = true;}";
				}
			else
				{
				mySubScript += "for (FR_loop = FR_Select.length-1; FR_loop > -1; FR_loop --){";
				mySubScript += "try {";
				mySubScript += "myFR_check = FR_Select[FR_loop].search(FR_What, FR_WholeWord, true, FR_ForWhat);";
				mySubScript += "} catch (e) {UMT_OpError = true;}}";
				}
			mySubScript += "return (myFR_check.length);}";
			app.doScript(mySubScript, ScriptLanguage.javascript);
			//standard CS/CS2 settings functions
			function myScriptFRClr()
				{
				app.findPreferences = NothingEnum.nothing;
				app.changePreferences = NothingEnum.nothing;
				if (myUMT_Lng_Name != UMT_Lng_Any) app.findPreferences.appliedLanguage = UMT_LngList[myUMT_Lng_DropDown];
				}
			function myScriptFRAdv(FR_What, FR_ForWhat, FR_Styles)
				{
				myScriptFRClr();
				if (FR_Styles[0] != "") app.findPreferences.appliedParagraphStyle = UMT_PStyleList[HJ_IndexOfArray(UMT_PStyleNames, FR_Styles[0])];
				if (FR_Styles[1] != "") app.changePreferences.appliedParagraphStyle = UMT_PStyleList[HJ_IndexOfArray(UMT_PStyleNames, FR_Styles[1])];
				if (FR_Styles[2] != "") app.findPreferences.appliedCharacterStyle = UMT_CStyleList[HJ_IndexOfArray(UMT_CSpList, FR_Styles[2])];
				if (FR_Styles[3] != "") app.changePreferences.appliedCharacterStyle = UMT_CStyleList[HJ_IndexOfArray(UMT_CSpList, FR_Styles[3])];
				if ((FR_Styles[4] != false) && (FR_Styles[4] != undefined)) app.changePreferences.noBreak = true;
				if ((FR_Styles[6] != "") && (FR_Styles[6] != undefined)) app.findPreferences.fontStyle = "" + FR_Styles[6];
				if ((FR_Styles[7] != "") && (FR_Styles[7] != undefined)) app.changePreferences.fontStyle = "" + FR_Styles[7];
				if ((FR_Styles[8] != "") && (FR_Styles[8] != undefined)) app.findPreferences.appliedFont = "" + FR_Styles[8];
				if ((FR_Styles[9] != "") && (FR_Styles[9] != undefined)) app.changePreferences.appliedFont = "" + FR_Styles[9];
				return (myScriptFR(FR_What, FR_ForWhat, FR_Styles[5]));
				}
			}
		else//FR for ID CS3
			{
			//standard CS3 search functions
			var mySubScript = "function myScriptFR(FR_What, FR_ForWhat){var myFR_check = new Array;";
			mySubScript += "app.findTextPreferences.findWhat = FR_What;app.changeTextPreferences.changeTo = FR_ForWhat;";
			if ((FR_Select.length == 1) && (FR_Select[0].constructor.name == "Text"))
				{
				mySubScript += "try {";
				mySubScript += "myFR_check = myDocSelectionZero.changeText();";
				mySubScript += "} catch (e) {UMT_OpError = true;}";
				}
			else
				{
				mySubScript += "for (FR_loop = FR_Select.length-1; FR_loop > -1; FR_loop --){";
				mySubScript += "try {";
				mySubScript += "myFR_check = FR_Select[FR_loop].changeText();";
				mySubScript += "} catch (e) {UMT_OpError = true;}}";
				}
			mySubScript += "return (myFR_check.length);}";
			//grep CS3 search functions
			mySubScript += "function FRG_Search(FRG_What, FRG_ForWhat){";
			mySubScript += "app.findGrepPreferences.findWhat = FRG_What;app.changeGrepPreferences.changeTo = FRG_ForWhat;";
			mySubScript += "var myFRG_check = new Array;";
			if ((FR_Select.length == 1) && (FR_Select[0].constructor.name == "Text"))
				{
				mySubScript += "try {";
				mySubScript += "myFRG_check = myDocSelectionZero.changeGrep();";
				mySubScript += "} catch (e) {UMT_OpError = true;}";
				}
			else
				{
				mySubScript += "for (FRG_loop = FR_Select.length-1; FRG_loop > -1; FRG_loop --){";
				mySubScript += "try {";
				mySubScript += "myFRG_check = FR_Select[FRG_loop].changeGrep();";
				mySubScript += "} catch (e) {UMT_OpError = true;}}";
				}
			mySubScript += "return (myFRG_check.length);}";
			app.doScript(mySubScript, ScriptLanguage.javascript);
			//standard CS3 settings functions
			function myScriptFRClr()
				{
				app.findTextPreferences = NothingEnum.nothing;
				app.changeTextPreferences = NothingEnum.nothing;
				app.findChangeTextOptions.includeFootnotes = true;
				app.findChangeTextOptions.includeHiddenLayers = false;
				app.findChangeTextOptions.includeLockedLayersForFind = false;
				app.findChangeTextOptions.includeLockedStoriesForFind = false;
				app.findChangeTextOptions.includeMasterPages = false;
				app.findChangeTextOptions.caseSensitive = true;
				app.findChangeTextOptions.wholeWord = false;
				if (myUMT_Lng_Name != UMT_Lng_Any) app.findTextPreferences.appliedLanguage = UMT_LngList[myUMT_Lng_DropDown];
				}
			function myScriptFRAdv(FR_What, FR_ForWhat, FR_Styles)
				{
				myScriptFRClr();
				(FR_Styles[0] != "") ? (app.findTextPreferences.appliedParagraphStyle = UMT_PStyleList[HJ_IndexOfArray(UMT_PStyleNames, FR_Styles[0])]) : {};
				(FR_Styles[1] != "") ? (app.changeTextPreferences.appliedParagraphStyle = UMT_PStyleList[HJ_IndexOfArray(UMT_PStyleNames, FR_Styles[1])]) : {};
				(FR_Styles[2] != "") ? (app.findTextPreferences.appliedCharacterStyle = UMT_CStyleList[HJ_IndexOfArray(UMT_CSpList, FR_Styles[2])]) : {};
				(FR_Styles[3] != "") ? (app.changeTextPreferences.appliedCharacterStyle = UMT_CStyleList[HJ_IndexOfArray(UMT_CSpList, FR_Styles[3])]) : {};
				((FR_Styles[4] != false) && (FR_Styles[4] != undefined)) ? (app.changeTextPreferences.noBreak = true) : {};
				((FR_Styles[5] != false) && (FR_Styles[5] != undefined)) ? (app.findChangeTextOptions.wholeWord = true) : {};
				((FR_Styles[6] != "") && (FR_Styles[6] != undefined)) ? (app.findTextPreferences.fontStyle = "" + FR_Styles[6]) : {};
				((FR_Styles[7] != "") && (FR_Styles[7] != undefined)) ? (app.changeTextPreferences.fontStyle = "" + FR_Styles[7]) : {};
				((FR_Styles[8] != "") && (FR_Styles[8] != undefined)) ? (app.findTextPreferences.appliedFont = "" + FR_Styles[8]) : {};
				((FR_Styles[9] != "") && (FR_Styles[9] != undefined)) ? (app.changeTextPreferences.appliedFont = "" + FR_Styles[9]) : {};
				return (myScriptFR(FR_What, FR_ForWhat));
				}
			//grep CS3 settings functions
			function myScriptFRGClr()
				{
				app.findGrepPreferences = NothingEnum.nothing;
				app.changeGrepPreferences = NothingEnum.nothing;
				app.findChangeGrepOptions.includeFootnotes = true;
				app.findChangeGrepOptions.includeHiddenLayers = false;
				app.findChangeGrepOptions.includeLockedLayersForFind = false;
				app.findChangeGrepOptions.includeLockedStoriesForFind = false;
				app.findChangeGrepOptions.includeMasterPages = false;
				(myUMT_Lng_Name != UMT_Lng_Any) ? (app.findGrepPreferences.appliedLanguage = UMT_LngList[myUMT_Lng_DropDown]) : {};
				}
			function FRG_SearchAdv(FRG_What, FRG_ForWhat, FRG_Style, FRG_NBr)
				{
				myScriptFRGClr();
				(FRG_Style != "") ? (app.changeGrepPreferences.appliedCharacterStyle = UMT_CStyleList[HJ_IndexOfArray(UMT_CSpList, FRG_Style)]) : {};
				(FRG_NBr != undefined) ? (app.changeGrepPreferences.noBreak = FRG_NBr) : {};
				return (FRG_Search(FRG_What, FRG_ForWhat));
				}
			//progress creation and functions
			myUMT_Progress = new Window("window", UMT_Script);
			myUMT_Progress.size = [400, 80];
			with (myUMT_Progress)
				{
				myUMT_Progress.myProgressTxt = add("statictext", [6, 6, 376, 28], "");
				myUMT_Progress.myProgressBar = add("progressbar", [6, 30, 376, 42], 0, 100);
				}
				myUMT_Progress.show();
			function myUMT_SetProgress(mySP_Texts, mySP_Value)
				{
				myUMT_Progress.myProgressTxt.text = mySP_Texts;
				myUMT_Progress.myProgressBar.value = mySP_Value;
				(mySP_Texts == "") ? (myUMT_Progress.hide()) : {};
				}
			}
		(myUMT_AppVersion < 5) ? (UMT_OperateCS1()) : (UMT_OperateCS3());
		if (UMT_OpError)
			if (confirm(UMT_Errors)) app.doScript(File(app.activeScript));
		}
	//user clicked Cancel, so remove the dialog box from memory
	else myUMT_Dialog.destroy();
	}//end char - don't touch!!

//opened documents&selection checking function
function myScriptSelectCheck(FR_WholeDoc)
	{
	FR_Select = new Array;
	if (FR_WholeDoc == 0)
		{
		var myDocStories = myDoc.stories;
		for (FR_loop = myDocStories.length-1; FR_loop > -1 ; FR_loop --)
			{
			(myDocStories[FR_loop].contents.length > 1) ? (FR_Select.push(myDocStories[FR_loop])) : {};
			for (FR_loopX = myDocStories[FR_loop].tables.length-1; FR_loopX > -1; FR_loopX --)
				{
				(myDocStories[FR_loop].tables[FR_loopX].contents.length > 1) ? (FR_Select.push(myDocStories[FR_loop].tables[FR_loopX])) : {};
				}
			}
		}
	if (FR_WholeDoc == 1)
		{
		for (FR_loop = myDocSelection.length-1; FR_loop > -1 ; FR_loop --)
			{
			if ((myDocSelection[FR_loop].constructor.name == "Text") && (myDocSelection[FR_loop].contents.length > 1))
				{
				if (myUMT_AppVersion < 4)
					{
					if (myDocSelection[FR_loop].parentStory.textFrames.length > 1)
						for (FR_loopX = myDocSelection[FR_loop].parentStory.textFrames.length-1; FR_loopX > -1; FR_loopX --)
							{
							FR_Select.push(myDocSelection[FR_loop].parentStory.textFrames[FR_loopX]);
							}
					else if (myDocSelection[FR_loop].parentStory.textFrames[0].contents.length == myDocSelection[FR_loop].contents.length)
							FR_Select.push(myDocSelection[FR_loop].parentStory.textFrames[0]);
						else (FR_Select.push(myDocSelection[FR_loop]));
					}
				else if (myDocSelection[FR_loop].parentTextFrames.length > 1)
					for (FR_loopX = myDocSelection[FR_loop].parentTextFrames.length-1; FR_loopX > -1; FR_loopX --)
						{
						FR_Select.push(myDocSelection[FR_loop].parentTextFrames[FR_loopX]);
						}
				else if (myDocSelection[FR_loop].parentTextFrames[0].contents.length == myDocSelection[FR_loop].contents.length)
						FR_Select.push(myDocSelection[FR_loop].parentTextFrames[0]);
					else (FR_Select.push(myDocSelection[FR_loop]));
				}
			if ((myDocSelection[FR_loop].constructor.name == "Cell") || (myDocSelection[FR_loop].constructor.name == "Character")
			|| (myDocSelection[FR_loop].constructor.name == "Column") || (myDocSelection[FR_loop].constructor.name == "Line")
			|| (myDocSelection[FR_loop].constructor.name == "Paragraph") || (myDocSelection[FR_loop].constructor.name == "Row")
			|| (myDocSelection[FR_loop].constructor.name == "Table") || (myDocSelection[FR_loop].constructor.name == "TextColumn")
			|| (myDocSelection[FR_loop].constructor.name == "TextFrame") || (myDocSelection[FR_loop].constructor.name == "TextStyleRange")
			|| (myDocSelection[FR_loop].constructor.name == "TextPath") || (myDocSelection[FR_loop].constructor.name == "Word"))
				{
				try
					{
					if (myDocSelection[FR_loop].contents.length > 1) (FR_Select.push(myDocSelection[FR_loop]));
					for (FR_loopX = myDocSelection[FR_loop].tables.length-1; FR_loopX > -1; FR_loopX --)
						{
						(myDocSelection[FR_loop].tables[FR_loopX].contents.length > 1) ? (FR_Select.push(myDocSelection[FR_loop].tables[FR_loopX])) : {};
						}
					}
				catch (e) {}
				}
			if (myDocSelection[FR_loop].constructor.name == "Group")
				{
				for (FR_loopX = myDocSelection[FR_loop].textFrames.length-1; FR_loopX > -1; FR_loopX --)
					{
					(myDocSelection[FR_loop].textFrames[FR_loopX].contents.length > 1) ? (FR_Select.push(myDocSelection[FR_loop].textFrames[FR_loopX])) : {};
					}
				for (FR_loopX = myDocSelection[FR_loop].groups.length-1; FR_loopX > -1; FR_loopX --)
					{
					for (FR_loopY = myDocSelection[FR_loop].textFrames.length-1; FR_loopY > -1; FR_loopY --)
						{
						try
							{
							(myDocSelection[FR_loop].groups[FR_loopX].textFrames[FR_loopY].contents.length > 1) ? (FR_Select.push(myDocSelection[FR_loop].groups[FR_loopX].textFrames[FR_loopY])) : {};
							}
						catch (e) {}
						}
					}
				}
			}
		}
	if (FR_WholeDoc == 2)
		{
		(myDocSelectionZero.constructor.name == "TextFrame") ? (FR_Select.push(myDocSelectionZero.parentStory)) : {};
		}
	if (FR_WholeDoc > 2)
		{
		for (FR_loop = 0; FR_loop < myUMT_WOnLayers[FR_WholeDoc-3].textFrames.length; FR_loop ++)
			{
			(myUMT_WOnLayers[FR_WholeDoc - 3].textFrames[FR_loop].contents.length > 1) ? (FR_Select.push(myUMT_WOnLayers[FR_WholeDoc - 3].textFrames[FR_loop])) : {};
			}
		}
	}

//do all corrections in CS and CS2
function UMT_OperateCS1()
	{
	//clear settings
	myScriptFRClr();
	//remove doubled spaces
	if (myUMT_DblSp_Check)
		{
		do {} while (myScriptFR("^s", " "));
		do {} while (myScriptFR("  ", " "));
		}
	//remove doubled tabs
	if (myUMT_DblTab_Check)
		{
		do {} while (myScriptFR("^t^t", "^t"));
		}
	//remove doubled carriage returns
	if (myUMT_DblRet_Check)
		{
		do {} while (myScriptFR("^p^p", "^p"));
		do {} while (myScriptFR("^n^n", "^n"));
		do {} while (myScriptFR("^p^n", "^p"));
		do {} while (myScriptFR("^n^p", "^p"));
		}
	//remove extra spaces near tabs and carriage returns
	if (myUMT_RemSps_Check)
		{
		do {} while (myScriptFR(" ^p", "^p"));
		do {} while (myScriptFR(" ^n", "^n"));
		do {} while (myScriptFR(" ^t", "^t"));
		do {} while (myScriptFR("^p ", "^p"));
		do {} while (myScriptFR("^n ", "^n"));
		do {} while (myScriptFR("^t ", "^t"));
		}
	//quotation marks correction
	if (myUMT_QuotLng_Check)
		{
		//change nontypographic quotes to typographic
		for (x = 0; x < UMT_AnyWSp.length; x ++)
			{
			myScriptFR(UMT_AnyWSp[x] + "<0022>", UMT_AnyWSp[x] + UMT_QuotTOp[myUMT_QuotLng_DropDown]);
			}
		myScriptFR("<0022>", UMT_QuotTCl[myUMT_QuotLng_DropDown]);
		//add spaces outside open quotes
		var myUMT_TmpArr = UMT_AnyLetter.concat(UMT_AnyDigit, UMT_AnyPun, UMT_AnyBrC);
		for (x = 0; x < myUMT_TmpArr.length; x ++)
			{
			myScriptFR(myUMT_TmpArr[x] + UMT_QuotTOp[myUMT_QuotLng_DropDown], myUMT_TmpArr[x] + " " + UMT_QuotTOp[myUMT_QuotLng_DropDown]);
			}
		//add spaces outside close quotes
		var myUMT_TmpArr = UMT_AnyLetter.concat(UMT_AnyDigit, UMT_AnyBrO);
		for (x = 0; x < myUMT_TmpArr.length; x ++)
			{
			myScriptFR(UMT_QuotTCl[myUMT_QuotLng_DropDown] + myUMT_TmpArr[x], UMT_QuotTCl[myUMT_QuotLng_DropDown] + " " + myUMT_TmpArr[x]);
			}
		//remove spaces inside open quotes
		myScriptFR(UMT_QuotTOp[myUMT_QuotLng_DropDown] + " ", UMT_QuotTOp[myUMT_QuotLng_DropDown]);
		//remove spaces inside close quotes
		myScriptFR(" " + UMT_QuotTCl[myUMT_QuotLng_DropDown], UMT_QuotTCl[myUMT_QuotLng_DropDown]);
		//french quotation marks - add thin space inside
		if (myUMT_QuotLng_DropDown == 1)
			{
			myScriptFR(UMT_QuotTOp[myUMT_QuotLng_DropDown], UMT_QuotTOp[myUMT_QuotLng_DropDown] + "<2009>");
			myScriptFR(UMT_QuotTCl[myUMT_QuotLng_DropDown], "<2009>" + UMT_QuotTCl[myUMT_QuotLng_DropDown]);
			myScriptFR("<2009><2009>", "<2009>");
			}
		}
	//insert space before
	if (myUMT_InsSp_b_Check)
		{
		var myUMT_FindArray = UMT_CreateArray(myUMT_InsSp_b_Edit);
		var myUMT_TmpArr = UMT_AnyLetter.concat(UMT_AnyPun, UMT_AnyBrC);
		(myUMT_QuotLng_Check) ? (myUMT_TmpArr.push(UMT_QuotTCl[myUMT_QuotLng_DropDown])) : {};
		for (x = 0; x < myUMT_FindArray.length; x ++)
			{
			for (y = 0; y < myUMT_TmpArr.length; y ++)
				{
				myScriptFR(myUMT_TmpArr[y] + myUMT_FindArray[x], myUMT_TmpArr[y] + " " + myUMT_FindArray[x]);
				}
			}
		}
	//insert space after
	if (myUMT_InsSp_a_Check)
		{
		var myUMT_FindArray = UMT_CreateArray(myUMT_InsSp_a_Edit);
		var myUMT_TmpArr = UMT_AnyLetter.concat(UMT_AnyBrO);
		(myUMT_QuotLng_Check) ? (myUMT_TmpArr.push(UMT_QuotTOp[myUMT_QuotLng_DropDown])) : {};
		for (x = 0; x < myUMT_FindArray.length; x ++)
			{
			for (y = 0; y < myUMT_TmpArr.length; y ++)
				{
				myScriptFR(myUMT_FindArray[x] + myUMT_TmpArr[y], myUMT_FindArray[x] + " " + myUMT_TmpArr[y]);
				}
			}
		}
	//remove space before
	if (myUMT_RemSp_b_Check)
		{
		var myUMT_FindArray = UMT_CreateArray(myUMT_RemSp_b_Edit);
		for (x = 0; x < myUMT_FindArray.length; x ++)
			{
			do {} while (myScriptFR(" " + myUMT_FindArray[x], myUMT_FindArray[x]));
			}
		}
	//remove space after
	if (myUMT_RemSp_a_Check)
		{
		var myUMT_FindArray = UMT_CreateArray(myUMT_RemSp_a_Edit);
		for (x = 0; x < myUMT_FindArray.length; x ++)
			{
			do {} while (myScriptFR(myUMT_FindArray[x] + " ", myUMT_FindArray[x]));
			}
		}
	//change minus between spaces to halfpause or pause
	if (myUMT_MinusSpaces_Check)
		{
		var UMT_HyphsAll = ["^=", "^_"];
		for (x = 0; x < UMT_AnyWSp.length; x ++)
			{
			myScriptFR(UMT_AnyWSp[x] + "- ", UMT_AnyWSp[x] + UMT_HyphsAll[myUMT_ChngMin_DropDown] + " ");
			myScriptFR(UMT_AnyWSp[x] + "-^t", UMT_AnyWSp[x] + UMT_HyphsAll[myUMT_ChngMin_DropDown] + "^t");
			}
		}
	//change minus between digits to halfpause or pause or hard hyphen or figure dash
	if (myUMT_DigMin_Check)
		{
		var UMT_DigHyphsAll = ["^=", "^_", "^~", "<2012>"];
		for (x = 0; x < 10; x ++)
			{
			for (y = 0; y < 10; y ++)
				{
				myScriptFR(x + "-" + y, x + UMT_DigHyphsAll[myUMT_DigMin_DropDown] + y);
				}
			}
		}
	//insert hard space after...
	if (myUMT_After_Check)
		{
		var myUMT_FindArray = UMT_FilesLoader(myUMT_After_Name);
		var myUMT_TmpArr = UMT_AnyBrO.concat(UMT_AnyWSp);
		(myUMT_QuotLng_Check) ? (myUMT_TmpArr.push(UMT_QuotTOp[myUMT_QuotLng_DropDown])) : {};
		((myUMT_QuotLng_Check) && (myUMT_QuotLng_DropDown == 1)) ? (myUMT_TmpArr.push("<2009>")) : {};
		for (x = 0; x < myUMT_FindArray.length; x ++)
			{
			for (y = 0; y < myUMT_TmpArr.length; y ++)
				{
				myScriptFR(myUMT_TmpArr[y] + myUMT_FindArray[x] + " ", myUMT_TmpArr[y] + myUMT_FindArray[x] + "^s");
				}
			}
		}
	//insert hard space before...
	if (myUMT_Before_Check)
		{
		var myUMT_FindArray = UMT_FilesLoader(myUMT_Before_Name);
		var myUMT_TmpArr = UMT_AnyPun.concat(UMT_AnyBrC, UMT_AnyWSp, "<2009>");
		(myUMT_QuotLng_Check) ? (myUMT_TmpArr.push(UMT_QuotTCl[myUMT_QuotLng_DropDown])) : {};
		((myUMT_QuotLng_Check) && (myUMT_QuotLng_DropDown == 1)) ? (myUMT_TmpArr.push("<2009>")) : {};
		for (x = 0; x < myUMT_FindArray.length; x ++)
			{
			for (y = 0; y < myUMT_TmpArr.length; y ++)
				{
				myScriptFR(" " + myUMT_FindArray[x] + myUMT_TmpArr[y], "^s" + myUMT_FindArray[x] + myUMT_TmpArr[y]);
				}
			}
		}
	//change hard spaces to space with "No break" attribute or to space with user style
	if (myUMT_ChgSp_Check)
		{
		if (myUMT_ChgSp_DropDown == 0)
			{
			myScriptFRAdv("^s", " ", ["", "", "", "", true]);
			}
		else myScriptFRAdv("^s", " ", ["", "", "", UMT_ChkStyle(false, UMT_CSpList[myUMT_ChgSp_DropDown])]);
		}
	//set internet adresses style
	if ((myUMT_WWW_Check) && (myUMT_WWW_DropDown > 0))
		{
		if ((FR_Select.length == 1) && (FR_Select != myDoc))
			{
			var myUMT_DocText = myDocSelectionZero.contents;
			}
		else
			{
			var myUMT_DocText = "";
			for (x = 0; x < FR_Select.length; x ++)
				{
				myUMT_DocText += (" " + FR_Select[x].contents);
				}
			}
		//index all internet adresses
		var myUMT_RegNetExp = /((http[s]*:\/\/)|(ftp:\/\/))*[\w]+[\w\.\-\_]*[\.\@][\w\.\/\?=\-\_\<\>\%\$\@\&\;]*\.\w[a-zA-Z]+/g;
		var myUMT_TmpArr = myUMT_DocText.match(myUMT_RegNetExp);
		if ((myUMT_TmpArr != null) && (myUMT_TmpArr.length != 0))
			{
			myUMT_TmpArr.sort();
			for (x = myUMT_TmpArr.length-1; x > 0; x --)
				{
				(myUMT_TmpArr[x] == myUMT_TmpArr[x-1]) ? (myUMT_TmpArr.splice(x,1)) : {};
				}
			myUMT_TmpArr.sort(HJ_SortByLengthDown);
			for (x = 0; x < myUMT_TmpArr.length; x ++)
				{
				myScriptFRAdv(myUMT_TmpArr[x], "", ["", "", "", UMT_ChkStyle(false, UMT_CSpWWW[myUMT_WWW_DropDown])]);
				}
			}
		}
	//apply changes from file
	(myUMT_AdFile_Check) ? (UMT_AdditionalFileAction()) : {};
	//clear settings at end
	myUMT_Lng_Name = UMT_Lng_Any;
	myScriptFRClr();
	}

//do all corrections in CS3
function UMT_OperateCS3()
	{
	//clear settings
	myScriptFRClr();
	myScriptFRGClr();
	//remove doubled spaces
	if (myUMT_DblSp_Check)
		{
		myUMT_SetProgress(UMT_Doubled + " " + UMT_DblSp, 5);
		FRG_Search("([ ]|[~s]|[~S])( |~s|~S)+", " ");
		}
	//remove doubled tabs
	if (myUMT_DblTab_Check)
		{
		myUMT_SetProgress(UMT_Doubled + " " + UMT_DblTab, 10);
		FRG_Search("[\\t](\\t)+", "\\t");
		}
	//remove doubled carriage returns
	if (myUMT_DblRet_Check)
		{
		myUMT_SetProgress(UMT_Doubled + " " + UMT_DblRet, 15);
		FRG_Search("[\\n](\\n)+", "\\n");
		FRG_Search("[\\r|\\n](\\r|\\n)+", "\\r");
		}
	//remove extra spaces near tabs and carriage returns
	if (myUMT_RemSps_Check)
		{
		myUMT_SetProgress(UMT_RemSps, 20);
		FRG_Search("\\n[ ]+", "\\n");
		FRG_Search("[ ]+\\n", "\\n");
		FRG_Search("\\t[ ]+", "\\t");
		FRG_Search("[ ]+\\t", "\\t");
		FRG_Search("\\r[ ]+", "\\r");
		FRG_Search("[ ]+\\r", "\\r");
		}
	//quotation marks correction
	if (myUMT_QuotLng_Check)
		{
		myUMT_SetProgress(UMT_QuotTyp + " " + UMT_QuotTAr[myUMT_QuotLng_DropDown], 25);
		FRG_Search("^~\"", UMT_QuotTOp[myUMT_QuotLng_DropDown]);
		FRG_Search("([\\s])~\"", "$1" + UMT_QuotTOp[myUMT_QuotLng_DropDown]);
		FRG_Search("~\"", UMT_QuotTCl[myUMT_QuotLng_DropDown]);
		FRG_Search("([^\\s])(" + UMT_QuotTOp[myUMT_QuotLng_DropDown] + ")", "$1 $2");
		FRG_Search("(" + UMT_QuotTCl[myUMT_QuotLng_DropDown] + ")([\\(|\\{|\\[~}])", "$1 $2");
		FRG_Search("[ ]+(" + UMT_QuotTCl[myUMT_QuotLng_DropDown] + ")", "$1");
		FRG_Search("(" + UMT_QuotTOp[myUMT_QuotLng_DropDown] + ")[ ]+", "$1");
		if (myUMT_QuotLng_DropDown == 1)
			{
			FRG_Search("(" + UMT_QuotTOp[myUMT_QuotLng_DropDown] + ")([^\u2009])", "$1\u2009$2");
			FRG_Search("([^\u2009])(" + UMT_QuotTCl[myUMT_QuotLng_DropDown] + ")", "$1\u2009$2");
			}
		}
	//insert space before
	if (myUMT_InsSp_b_Check)
		{
		myUMT_SetProgress(UMT_InsSp_b + " " + myUMT_InsSp_b_Edit, 30);
		var myUMT_FindArray = UMT_CreateArray(myUMT_InsSp_b_Edit);
		var myUMT_GrepWhat = "([^\\s|~{|\(|\{|[])("+FRG_Prepare(myUMT_FindArray[0]);
		for (x = 1; x < myUMT_FindArray.length; x ++)
			{
			myUMT_GrepWhat += "|";
			myUMT_GrepWhat += FRG_Prepare(myUMT_FindArray[x]);
			}
		myUMT_GrepWhat += ")";
		FRG_Search(myUMT_GrepWhat, "$1 $2");
		}
	//insert space after
	if (myUMT_InsSp_a_Check)
		{
		myUMT_SetProgress(UMT_InsSp_a + " " + myUMT_InsSp_a_Edit, 35);
		var myUMT_FindArray = UMT_CreateArray(myUMT_InsSp_a_Edit);
		var myUMT_GrepWhat = "([^\\d]["+FRG_Prepare(myUMT_FindArray[0]);
		for (x = 1; x < myUMT_FindArray.length; x ++)
			{
			myUMT_GrepWhat += "|";
			myUMT_GrepWhat += FRG_Prepare(myUMT_FindArray[x]);
			}
		myUMT_GrepWhat += "])([^\\s|\\.|,|;|:|\\(|\\{|\\[|~}])";
		FRG_Search(myUMT_GrepWhat, "$1 $2");
		}
	//remove space before
	if (myUMT_RemSp_b_Check)
		{
		myUMT_SetProgress(UMT_RemSp_b + " " + myUMT_RemSp_b_Edit, 40);
		var myUMT_FindArray = UMT_CreateArray(myUMT_RemSp_b_Edit);
		var myUMT_GrepWhat = "[ ]+("+FRG_Prepare(myUMT_FindArray[0]);
		for (x = 1; x < myUMT_FindArray.length; x ++)
			{
			myUMT_GrepWhat += "|";
			myUMT_GrepWhat += FRG_Prepare(myUMT_FindArray[x]);
			}
		myUMT_GrepWhat += ")";
		FRG_Search(myUMT_GrepWhat, "$1", "");
		}
	//remove space after
	if (myUMT_RemSp_a_Check)
		{
		myUMT_SetProgress(UMT_RemSp_a + " " + myUMT_RemSp_a_Edit, 45);
		var myUMT_FindArray = UMT_CreateArray(myUMT_RemSp_a_Edit);
		var myUMT_GrepWhat = "(["+FRG_Prepare(myUMT_FindArray[0]);
		for (x = 1; x < myUMT_FindArray.length; x ++)
			{
			myUMT_GrepWhat += "|";
			myUMT_GrepWhat += FRG_Prepare(myUMT_FindArray[x]);
			}
		myUMT_GrepWhat += "])[ ]+";
		FRG_Search(myUMT_GrepWhat, "$1", "");
		}
	//change minus between spaces to halfpause or pause
	if (myUMT_MinusSpaces_Check)
		{
		myUMT_SetProgress(UMT_ChngMin + " " + UMT_Hyphs[myUMT_ChngMin_DropDown], 50);
		var UMT_HyphsAll = ["~=", "~_"];
		FRG_Search("^- ", UMT_HyphsAll[myUMT_ChngMin_DropDown] + " ");
		FRG_Search("(\\s)-(\\s)", "$1" + UMT_HyphsAll[myUMT_ChngMin_DropDown] + "$2");
		}
	//change minus between digits to halfpause or pause or hard hyphen or figure dash
	if (myUMT_DigMin_Check)
		{
		myUMT_SetProgress(UMT_DigMin + " " + UMT_DigHyph[myUMT_DigMin_DropDown], 55);
		var UMT_DigHyphsAll = ["~=", "~_", "~~", "\u2012"];
		FRG_Search("(\\d)-(\\d)", "$1" + UMT_DigHyphsAll[myUMT_DigMin_DropDown] + "$2");
		}
	//insert hard space after...
	if (myUMT_After_Check)
		{
		myUMT_SetProgress(UMT_After + " " + myUMT_After_Name, 60);
		var myUMT_FindArray = UMT_FilesLoader(myUMT_After_Name);
		var myUMT_UniArray = new Array;
		FRG_GetUnicodes(myUMT_FindArray, myUMT_UniArray);
		var myUMT_GrepWhat = "((?<=\\<("+FRG_Prepare(myUMT_FindArray[0]);
		for (x = 1; x < myUMT_FindArray.length; x ++)
			{
			myUMT_GrepWhat += ")) )|((?<=\\<(";
			myUMT_GrepWhat += FRG_Prepare(myUMT_FindArray[x]);
			}
		myUMT_GrepWhat += ")) )";
		FRG_Search(myUMT_GrepWhat, "~s");
		if (myUMT_UniArray.length > 0)
			{
			var myUMT_GrepWhat = "(("+FRG_Prepare(myUMT_UniArray[0]);
			for (x = 1; x < myUMT_UniArray.length; x ++)
				{
				myUMT_GrepWhat += ")|(";
				myUMT_GrepWhat += FRG_Prepare(myUMT_UniArray[x]);
				}
			myUMT_GrepWhat += "))( )";
			FRG_Search(myUMT_GrepWhat, "$1~s");
			}
		}
	//insert hard space before...
	if (myUMT_Before_Check)
		{
		myUMT_SetProgress(UMT_Before + " " + myUMT_Before_Name, 70);
		var myUMT_FindArray = UMT_FilesLoader(myUMT_Before_Name);
		var myUMT_UniArray = new Array;
		FRG_GetUnicodes(myUMT_FindArray, myUMT_UniArray);
		var myUMT_GrepWhat = "( (?=\\<("+FRG_Prepare(myUMT_FindArray[0]);
		for (x = 1; x < myUMT_FindArray.length; x ++)
			{
			(myUMT_GrepWhat[myUMT_GrepWhat.length-1] == ".") ? (myUMT_GrepWhat += ")))|( (?=\\<(") : (myUMT_GrepWhat += "\\>)))|( (?=\\<(");
			myUMT_GrepWhat += FRG_Prepare(myUMT_FindArray[x]);
			}
		myUMT_GrepWhat += ")))";
		FRG_Search(myUMT_GrepWhat, "~s");
		if (myUMT_UniArray.length > 0)
			{
			var myUMT_GrepWhat = "( )(("+FRG_Prepare(myUMT_UniArray[0]);
			for (x = 1; x < myUMT_UniArray.length; x ++)
				{
				myUMT_GrepWhat += ")|(";
				myUMT_GrepWhat += FRG_Prepare(myUMT_UniArray[x]);
				}
			myUMT_GrepWhat += "))";
			FRG_Search(myUMT_GrepWhat, "~s$2");
			}
		}
	//change hard spaces to space with "No break" attribute or to space with user style
	if (myUMT_ChgSp_Check)
		{
		myUMT_SetProgress(UMT_ChgSp + " " + UMT_CSpList[myUMT_ChgSp_DropDown], 80);
		if (myUMT_ChgSp_DropDown == 0)
			{
			FRG_SearchAdv("~s", " ", "", true);
			}
		else if (myUMT_ChgSp_Name != UMT_HardCS3)
			{
			FRG_SearchAdv("~s", " ", UMT_ChkStyle(false, UMT_CSpList[myUMT_ChgSp_DropDown]));
			}
		else FRG_Search("~s", "~S");
		}
	//set internet adresses stylemy
	if ((myUMT_WWW_Check) && (myUMT_WWW_DropDown > 0))
		{
		myUMT_SetProgress(UMT_WWW + " " + UMT_CSpWWW[myUMT_WWW_DropDown], 90);
		var myUMT_GrepWhat = "((http[s]*:\\/\\/)|(ftp:\\/\\/))*[\\w]+[\\w\\.\\-\\_]*[\\.\\@][\\w\\.\\/\\?=\\-\\_\\<\\>\\%\\$\\@\\&\\;]*\\.\\w[a-zA-Z]+";
		FRG_SearchAdv(myUMT_GrepWhat, "", UMT_ChkStyle(false, UMT_CSpWWW[myUMT_WWW_DropDown]));
		}
	//apply changes from file
	(myUMT_AdFile_Check) ? (UMT_AdditionalFileAction()) : {};
	//clear settings at end
	myUMT_Lng_Name = UMT_Lng_Any;
	myScriptFRClr();
	myScriptFRGClr();
	myUMT_SetProgress("", 100);
	}

//apply changes from file
function UMT_AdditionalFileAction()
	{
	(myUMT_AppVersion > 3.99) ? (myUMT_SetProgress(UMT_AdFile + " " + myUMT_AdFile_Name, 95)) : {};
	var myUMT_FindArray = UMT_FilesLoader(myUMT_AdFile_Name);
	if (myUMT_FindArray.length%2 != 0)
		{
		alert(UMT_noChF + myUMT_AdFile_Name);
		}
	else
		{
		var x = 0;
		do
			{
			var myUMT_AdStyle = ["", "", "", "", false, false, "", "", "", ""];//findPStyle, changePStyle, findCStyle, changeCStyle, noBreak, wholeword, findFonStyle, changeFontStyle, findFontName, changeFontName
			var myUMT_AdFind = (myUMT_FindArray[x]).split("\t");
			var myUMT_AdChng = (myUMT_FindArray[x+1]).split("\t");
			for (y = 0; y < myUMT_AdFind.length; y ++)
				{
				((myUMT_AdFind[y]).indexOf("parastyle:") == 0) ? (myUMT_AdStyle[0] = UMT_ChkStyle(true, (myUMT_AdFind[y]).substring(10))) : {};
				((myUMT_AdFind[y]).indexOf("charstyle:") == 0) ? (myUMT_AdStyle[2] = UMT_ChkStyle(false, (myUMT_AdFind[y]).substring(10))) : {};
				(myUMT_AdFind[y] == "wholeword:true") ? (myUMT_AdStyle[5] = true) : {};
				(myUMT_AdFind[y] == "wholeword:false") ? (myUMT_AdStyle[5] = false) : {};
				((myUMT_AdFind[y]).indexOf("fontstyle:") == 0) ? (myUMT_AdStyle[6] = (myUMT_AdFind[y]).substring(10)) : {};
				((myUMT_AdFind[y]).indexOf("fontname:") == 0) ? (myUMT_AdStyle[8] = (myUMT_AdFind[y]).substring(9)) : {};
				}
			for (y = 0; y < myUMT_AdChng.length; y ++)
				{
				((myUMT_AdChng[y]).indexOf("parastyle:") == 0) ? (myUMT_AdStyle[1] = UMT_ChkStyle(true, (myUMT_AdChng[y]).substring(10))) : {};
				((myUMT_AdChng[y]).indexOf("charstyle:") == 0) ? (myUMT_AdStyle[3] = UMT_ChkStyle(false, (myUMT_AdChng[y]).substring(10))) : {};
				(myUMT_AdChng[y] == "nobreak:true") ? (myUMT_AdStyle[4] = true) : {};
				(myUMT_AdChng[y] == "nobreak:false") ? (myUMT_AdStyle[4] = false) : {};
				((myUMT_AdChng[y]).indexOf("fontstyle:") == 0) ? (myUMT_AdStyle[7] = (myUMT_AdChng[y]).substring(10)) : {};
				((myUMT_AdChng[y]).indexOf("fontname:") == 0) ? (myUMT_AdStyle[9] = (myUMT_AdChng[y]).substring(9)) : {};
				}
			//secure for deletion;)
			if ((myUMT_AdFind[0] == "") && (myUMT_AdChng[0] == "") && (myUMT_AdStyle[1] == "") && (myUMT_AdStyle[3] == "") && (myUMT_AdStyle[7] == "") && (myUMT_AdStyle[9] == ""))
				{
				myUMT_AdStyle[0] = "";
				myUMT_AdStyle[2] = "";
				myUMT_AdStyle[6] = "";
				myUMT_AdStyle[8] = "";
				}
				//alert(myUMT_AdStyle);
			myScriptFRAdv(myUMT_AdFind[0], myUMT_AdChng[0], myUMT_AdStyle);
			x = x + 2;
			}
		while (x < myUMT_FindArray.length);
		}
	}

//get one char unicode defs fo regexp
function FRG_GetUnicodes(FRG_FindArray, FRG_UniArray)
	{
	for (x = FRG_FindArray.length-1; x > -1; x --)
		{
		if ((FRG_FindArray[x]).length == 6) if ((FRG_FindArray[x]).match(new RegExp("\\<[0-9|a-f|A-F][0-9|a-f|A-F][0-9|a-f|A-F][0-9|a-f|A-F]>", "g")) != null)
				{
				FRG_UniArray.push(FRG_FindArray[x]);
				FRG_FindArray.splice(x,1);
				}
		}
	}

//prepare strings for grep
function FRG_Prepare(FRG_String)
	{
	FRG_String = FRG_String.replace(new RegExp("\\)", "g"), "\\)");
	FRG_String = FRG_String.replace(new RegExp("\\(", "g"), "\\(");
	FRG_String = FRG_String.replace(new RegExp("\\}", "g"), "\\}");
	FRG_String = FRG_String.replace(new RegExp("\\{", "g"), "\\{");
	FRG_String = FRG_String.replace(new RegExp("\\]", "g"), "\\]");
	FRG_String = FRG_String.replace(new RegExp("\\[", "g"), "\\[");
	FRG_String = FRG_String.replace(new RegExp("\\.", "g"), "\\.");
	FRG_String = FRG_String.replace(new RegExp("\\?", "g"), "\\?");
	FRG_String = FRG_String.replace(new RegExp("\\!", "g"), "\\!");
	FRG_String = FRG_String.replace(new RegExp("\\@", "g"), "\\@");
	FRG_String = FRG_String.replace(new RegExp("\\#", "g"), "\\#");
	FRG_String = FRG_String.replace(new RegExp("\\$", "g"), "\\$");
	FRG_String = FRG_String.replace(new RegExp("\\%", "g"), "\\%");
	FRG_String = FRG_String.replace(new RegExp("\\^", "g"), "\\^");
	FRG_String = FRG_String.replace(new RegExp("\\&", "g"), "\\&");
	FRG_String = FRG_String.replace(new RegExp("\\*", "g"), "\\*");
	FRG_String = FRG_String.replace(new RegExp("\\+", "g"), "\\+");
	FRG_String = FRG_String.replace(new RegExp("\\-", "g"), "\\-");
	FRG_String = FRG_String.replace(new RegExp("\\_", "g"), "\\_");
	FRG_String = FRG_String.replace(new RegExp("\\=", "g"), "\\=");
	FRG_String = FRG_String.replace(new RegExp("\\/", "g"), "\\/");
	FRG_String = FRG_String.replace(new RegExp("\\|", "g"), "\\|");
	FRG_String = FRG_String.replace(new RegExp("\\<", "g"), "\\<");
	//FRG_String = FRG_String.replace(new RegExp("\\", "g"), "\\");
	return(FRG_String);
	}

//change texts from edit fields to array and remove empty records
function UMT_CreateArray(myUMT_EditFieldText)
	{
	var myUMT_TmpArr = myUMT_EditFieldText.split("");
	for (z = myUMT_TmpArr.length-1; z > -1; z --)
		{
		((myUMT_TmpArr[z] == "") || (myUMT_TmpArr[z] == " ")) ? (myUMT_TmpArr.splice(z,1)) : {};
		}
	return (myUMT_TmpArr);
	}

//check styles existing
function UMT_ChkStyle(CS_StyleType, CS_StyleName)
	{
	var CS_style = "";
	var mySubScript = "for (CS_x = 0; CS_x < ";
	(CS_StyleType) ? (mySubScript += "UMT_PStyleNames") : (mySubScript += "UMT_CSpList");
	mySubScript += ".length; CS_x ++) {";
	mySubScript += "if (CS_StyleName == ";
	(CS_StyleType) ? (mySubScript += "UMT_PStyleNames") : (mySubScript += "UMT_CSpList");
	mySubScript += "[CS_x]) {";
	mySubScript += "CS_style = CS_StyleName; break; } }";
	app.doScript(mySubScript, ScriptLanguage.javascript);
	return (CS_style);
	}

//universal array loader
function UMT_FilesLoader(UMT_FLName)
	{
	var myUMT_FLArray = new Array;
	var myUMT_FLFolder = File(app.activeScript).parent;
	var myUMT_FLAdName = new File(myUMT_FLFolder + "/" + UMT_FLName);
	var myOpenedFile = myUMT_FLAdName.open("r", undefined, undefined);
	if (myOpenedFile)
		{
		var myUMT_FLArray = myUMT_FLAdName.read();
		myUMT_FLArray = myUMT_FLArray.split("\n");
		for (x = myUMT_FLArray.length-1; x > -1; x --)
			{
			(((myUMT_FLArray[x] + "") == "") || ((myUMT_FLArray[x] + "").indexOf("/") > -1)) ? (myUMT_FLArray.splice(x,1)) : {};
			}
		}
	else alert(UMT_noAdF + UMT_FLName);
	myUMT_FLAdName.close();
	return (myUMT_FLArray);
	}

//open preference file function
function UMT_PrefsFileOpen()
	{
	var myScriptFile = File(app.activeScript);
	var myScriptFolder = myScriptFile.parent;
	var myUMT_PrefsFileNN = myScriptFolder + "/" + "UMT2.2_prefs.txt";
	var myUMT_PrefsFile = File(myUMT_PrefsFileNN);
	var myOpenedFile = myUMT_PrefsFile.open("r", undefined, undefined);
	if (myOpenedFile)
		{
		var myUMT_PrefsArray = myUMT_PrefsFile.read();
		myUMT_PrefsArray = myUMT_PrefsArray.split("\n");
		if (myUMT_PrefsArray.length == 38)
			{
			myUMT_WorkOn_DropDown	= +(myUMT_PrefsArray[0] + "");
			myUMT_Lng_DropDown		= +(myUMT_PrefsArray[1] + "");
			myUMT_Lng_Name			= (myUMT_PrefsArray[2] + "");
			myUMT_DblSp_Check		= !!(+(myUMT_PrefsArray[3] + ""));
			myUMT_DblTab_Check		= !!(+(myUMT_PrefsArray[4] + ""));
			myUMT_DblRet_Check		= !!(+(myUMT_PrefsArray[5] + ""));
			myUMT_RemSps_Check		= !!(+(myUMT_PrefsArray[6] + ""));
			myUMT_QuotLng_Check		= !!(+(myUMT_PrefsArray[7] + ""));
			myUMT_QuotLng_DropDown	= +(myUMT_PrefsArray[8] + "");
			myUMT_InsSp_b_Check		= !!(+(myUMT_PrefsArray[9] + ""));
			myUMT_InsSp_a_Check		= !!(+(myUMT_PrefsArray[10] + ""));
			myUMT_RemSp_b_Check		= !!(+(myUMT_PrefsArray[11] + ""));
			myUMT_RemSp_a_Check		= !!(+(myUMT_PrefsArray[12] + ""));
			myUMT_InsSp_b_Edit		= (myUMT_PrefsArray[13] + "");
			myUMT_InsSp_a_Edit		= (myUMT_PrefsArray[14] + "");
			myUMT_RemSp_b_Edit		= (myUMT_PrefsArray[15] + "");
			myUMT_RemSp_a_Edit		= (myUMT_PrefsArray[16] + "");
			myUMT_MinusSpaces_Check	= !!(+(myUMT_PrefsArray[17] + ""));
			myUMT_ChngMin_DropDown	= +(myUMT_PrefsArray[18] + "");
			myUMT_After_Check		= !!(+(myUMT_PrefsArray[19] + ""));
			myUMT_After_DropDown	= +(myUMT_PrefsArray[20] + "");
			myUMT_After_Name		= (myUMT_PrefsArray[21] + "");
			myUMT_Before_Check		= !!(+(myUMT_PrefsArray[22] + ""));
			myUMT_Before_DropDown	= +(myUMT_PrefsArray[23] + "");
			myUMT_Before_Name		= (myUMT_PrefsArray[24] + "");
			myUMT_ChgSp_Check		= !!(+(myUMT_PrefsArray[25] + ""));
			myUMT_ChgSp_DropDown	= +(myUMT_PrefsArray[26] + "");
			myUMT_ChgSp_Name		= (myUMT_PrefsArray[27] + "");
			myUMT_WWW_Check			= !!(+(myUMT_PrefsArray[28] + ""));
			myUMT_WWW_DropDown		= +(myUMT_PrefsArray[29] + "");
			myUMT_WWW_Name			= (myUMT_PrefsArray[30] + "");
			myUMT_AdFile_Check		= !!(+(myUMT_PrefsArray[31] + ""));
			myUMT_AdFile_DropDown	= +(myUMT_PrefsArray[32] + "");
			myUMT_AdFile_Name		= (myUMT_PrefsArray[33] + "");
			myUMT_DigMin_Check		= !!(+(myUMT_PrefsArray[34] + ""));
			myUMT_DigMin_DropDown	= +(myUMT_PrefsArray[35] + "");
			myUMT_WorkOn_Name		= (myUMT_PrefsArray[36] + "");
			}
		}
	myUMT_PrefsFile.close();
	}

//save preference file function
function UMT_PrefsFileSave()
	{
	var myScriptFile = File(app.activeScript);
	var myScriptFolder = myScriptFile.parent;
	var myUMT_PrefsFileNN = myScriptFolder + "/" + "UMT2.2_prefs.txt";
	var myUMT_PrefsFile = File(myUMT_PrefsFileNN);
	var myOpenedFile = myUMT_PrefsFile.open("w", undefined, undefined);
	if (myOpenedFile)
		{
		myUMT_PrefsFile.writeln(myUMT_WorkOn_DropDown);
		myUMT_PrefsFile.writeln(myUMT_Lng_DropDown);
		myUMT_PrefsFile.writeln(myUMT_Lng_Name);
		myUMT_PrefsFile.writeln(+myUMT_DblSp_Check);
		myUMT_PrefsFile.writeln(+myUMT_DblTab_Check);
		myUMT_PrefsFile.writeln(+myUMT_DblRet_Check);
		myUMT_PrefsFile.writeln(+myUMT_RemSps_Check);
		myUMT_PrefsFile.writeln(+myUMT_QuotLng_Check);
		myUMT_PrefsFile.writeln(myUMT_QuotLng_DropDown);
		myUMT_PrefsFile.writeln(+myUMT_InsSp_b_Check);
		myUMT_PrefsFile.writeln(+myUMT_InsSp_a_Check);
		myUMT_PrefsFile.writeln(+myUMT_RemSp_b_Check);
		myUMT_PrefsFile.writeln(+myUMT_RemSp_a_Check);
		myUMT_PrefsFile.writeln(myUMT_InsSp_b_Edit);
		myUMT_PrefsFile.writeln(myUMT_InsSp_a_Edit);
		myUMT_PrefsFile.writeln(myUMT_RemSp_b_Edit);
		myUMT_PrefsFile.writeln(myUMT_RemSp_a_Edit);
		myUMT_PrefsFile.writeln(+myUMT_MinusSpaces_Check);
		myUMT_PrefsFile.writeln(myUMT_ChngMin_DropDown);
		myUMT_PrefsFile.writeln(+myUMT_After_Check);
		myUMT_PrefsFile.writeln(myUMT_After_DropDown);
		myUMT_PrefsFile.writeln(myUMT_After_Name);
		myUMT_PrefsFile.writeln(+myUMT_Before_Check);
		myUMT_PrefsFile.writeln(myUMT_Before_DropDown);
		myUMT_PrefsFile.writeln(myUMT_Before_Name);
		myUMT_PrefsFile.writeln(+myUMT_ChgSp_Check);
		myUMT_PrefsFile.writeln(myUMT_ChgSp_DropDown);
		myUMT_PrefsFile.writeln(myUMT_ChgSp_Name);
		myUMT_PrefsFile.writeln(+myUMT_WWW_Check);
		myUMT_PrefsFile.writeln(myUMT_WWW_DropDown);
		myUMT_PrefsFile.writeln(myUMT_WWW_Name);
		myUMT_PrefsFile.writeln(+myUMT_AdFile_Check);
		myUMT_PrefsFile.writeln(myUMT_AdFile_DropDown);
		myUMT_PrefsFile.writeln(myUMT_AdFile_Name);
		myUMT_PrefsFile.writeln(+myUMT_DigMin_Check);
		myUMT_PrefsFile.writeln(myUMT_DigMin_DropDown);
		myUMT_PrefsFile.writeln(myUMT_WorkOn_Name);
		}
	myUMT_PrefsFile.close();
	}

//check files by mask
function UMT_GetFiles(GF_Mask)
	{
	var GF_Files = new Array;
	var GF_Folder = File(app.activeScript).parent;
	GF_Files = GF_Folder.getFiles(GF_Mask);
	for (x = GF_Files.length-1; x > -1; x --)
		{
		if (GF_Files[x].constructor.name == "Folder")
			{
			GF_Files.splice(x,1);
			}
		else
			{
			var GF_Name = File(GF_Files[x]);
			var myOpenedFile = GF_Name.open("r", undefined, undefined);
			GF_Name.close();
			GF_Files[x] = File(GF_Files[x]).name;
			}
		}
	return (GF_Files);
	}

//special additional mainfunctions
function HJ_IndexOfArray(tab,val)
	{
	for (a=0; a<tab.length;a++) { if (tab[a]==val) return(a); }
	return(-1);
	}
function HJ_SortByLengthDown(a,b)
	{
	return(b.length-a.length)
	}
//end of UseMyTypo script (by Henryk Jursz, HenJ 2005-2020)